<?php 

	function processAjaxAction($action, $param1 = false, $param2 = false, $param3 = false, $param4 = false){
		
		global $settings, $user, $order, $db, $smarty, $custom_fields,
			$url_dinamic, $url_http, $url_https, $msg;
		
		$objResponse = new xajaxResponse();
		$objResponse->setCharEncoding("windows-1251");
		
		switch($action){
			// *** GIFT CERTIFICATE
			case "tc_check_gift_cert" : {
				if($user->auth_ok){
					$gift_cert = split("\|", $param1);
					$gift_cert_first_name = $gift_cert[0];
					$gift_cert_last_name = $gift_cert[1];
					$gift_cert_voucher = $gift_cert[2];
					$gift_flag = $gift_cert[3];

					if (count($gift_cert) > 4) {
						$shipping_method = $gift_cert[4];
						$result = $order->updateShippingMethod($db, $shipping_method);
						if($shipping_method > 0){
							$order->getShippingAmount($db, $error_message);
						}
						$order->checkFreeProducts($db);
						$order->recalcOrderData($db, $user->level);
					}

					$gift_error = '0';
					if ($gift_cert_first_name != '' || $gift_cert_last_name != '' || $gift_cert_voucher != '') {
						$gift_cert = new GiftCertificates($db);
						$gift_data = $gift_cert->GetOrderedGiftCert($gift_cert_first_name, $gift_cert_last_name, $gift_cert_voucher);
						if ($gift_data === false) {
							// provided data incorrect
							$gift_error = '1';
						} else {
							$gift_cert->SetOrderGiftCert($order->oid, $gift_cert_first_name, $gift_cert_last_name, $gift_cert_voucher);
							if ($gift_flag == '1') {
								$total_amount = $order->totalAmount; //-$order->shippingAmount-$order->taxAmount-($order->handlingSeparated?$order->handlingAmount:0.00);
								$balance = $gift_data['balance'];
								if ($total_amount > $balance) {
									$gift_error = '2';
									$gift_cert->UpdateOrderGCAmount($order->oid, $balance);
								} else {
									$order->updatePaymentMethod($db, "free");
								}
							}
						}
					}

					if ($gift_error == '1') {
						$objResponse->addAssign("gift_cert_error", "style.display", "block");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "none");
					} else if ($gift_error == '2') {
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "block");
						$objResponse->addScript("alert('The balance of gift certificate is less than order amount. The remainder is $".number_format($total_amount-$balance, 2)."')");
						$objResponse->addScript("altPaymentGiftCert('$total_amount', '$balance')");
					} else {
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "none");
						$objResponse->addScript("altPaymentGiftCert_new()");//GC fix if you user re enter the code which have balance more than equal to order total than let him compelete ordee
						$objResponse->addScript("continueGiftCert()");
					}
				}
				else{
					$objResponse->addAssign("document.location", "index.php?p=auth_error");
				}
				break;
			
			}
			// *** GIFT CERTIFICATE
		
			case "tc_set_payment_method" : {
				if($user->auth_ok){
					$order->updatePaymentMethod($db, $param1);
					$_SESSION["pc_method_id"] = $order->paymentMethodId;
					if($order->gift_cert_amount > 0 && $order->totalAmount > $order->gift_cert_amount){
						$objResponse->addAssign("gift_cert_error", "style.display", "none");
						$objResponse->addAssign("gift_cert_alt_payment", "style.display", "block");
						$objResponse->addScript("altPaymentGiftCert('$order->totalAmount', '$order->gift_cert_amount')");
					}
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
				}
				break;
			}
			
			case "opc_set_addresses" : 
			case "opc_continue_with_order" :
			case "opc_get_shipping_rates" : {
				if($user->auth_ok){
					
					$objResponse->addAssign("div_continue_with_order", "style.display", "none");
					
					//check custom fields
					$custom_field = isset($param1["custom_field"])?$param1["custom_field"]:array();
					$custom_field = is_array($custom_field)?$custom_field:array();
					
					//update billing address
					if($param1["paypal_ec_used"] == "0"){
						$billing_address = $param1["billing_address"];
						$user->UpdateBillingInfo($billing_address);
						if($settings["TaxAddress"] == "Billing"){
							$order->taxCountryId = $billing_address["country"];
							$order->taxStateId = $billing_address["state"];
							//$objResponse->addScript("alert('UpdateBillingInfo:-'+".$order->taxStateId."+'---billing_address:-'+".$billing_address['state'].")");
						}	
					}
					
					$billing_address_data = $user->getUserData();

					//update / set shipping address
					if(!$order->shippingDigital){
						
						$shipping_address_id = $param1["shipping_address_id"];
						switch($shipping_address_id){
							case "new" : {
								$shipping_address_data = $param1["shipping_address"];
								if(isset($param1["add_to_address_book"])){
									$address_id = $user->AddShippingAddress($shipping_address_data);
								}
								$order->updateShippingAddress($db, $shipping_address_data);
								$custom_fields->StoreCustomFields("shipping", $custom_field, $user->id, $order->oid, 0);
								break;
							}
							case "billing" : {
								$shipping_address_data = $billing_address;
								$shipping_address_data["name"] = $billing_address["fname"]." ".$billing_address["lname"];
								$order->updateShippingAddress($db, $shipping_address_data);
								break;
							}
							default : {
								$shipping_address_data = $user->GetShippingAddressById($shipping_address_id);
								$order->updateShippingAddress($db, $shipping_address_data);
								break;
							}
						}
						$_SESSION["opc_shipping_address_id"] = $shipping_address_id;
					}
					else{
						$objResponse->addScript("shipping_passed = 1;");
						$objResponse->addAssign("div_form_bottom_inside", "style.display", "block");
						$objResponse->addAssign("div_form_bottom", "style.display", "block");
					}

					$make_forms_textual = true;
					
					if($action == "opc_get_shipping_rates"){
						
						if($settings["ShippingCalcEnabled"] == "NO"){
							
							if($settings["ShippingInternational"] == "NO" && $shipping_address_data["country"] != $settings["ShippingOriginCountry"]){
								$objResponse->addAssign("div_form_bottom", "style.display", "none");
								$shipping_error_text = $smarty->fetch("one-page-checkout/form-shipping-error.html");
								$objResponse->addAssign("div_shipping_error", "innerHTML", $shipping_error_text);
								$objResponse->addAssign("div_shipping_error", "style.display", "block");
								
								$objResponse->addScript("shipping_passed = 0;");
								$objResponse->addAssign("div_form_bottom_inside", "style.display", "none");
								$objResponse->addScript("opcSetProcessPaymentButtonStatus(0)");
								$smarty->assign("is_international_error", "yes");
								$make_forms_textual = false;
							}
							else{
								$objResponse->addScript("shipping_passed = 1;");
								$objResponse->addAssign("div_form_bottom_inside", "style.display", "block");
								$objResponse->addAssign("div_form_bottom", "style.display", "block");
								$objResponse->addScript("opcSetProcessPaymentButtonStatus(1)");
								$smarty->assign("is_international_error", "no");
								$make_forms_textual = true;
							}
							$order->getTaxRates($db);
							$order->openShipping($db);
							$order->checkShippingDigital($db);
							$order->checkFreeProducts($db);
							$order->recalcOrderData($db, $user->level);
							$order->getShippingAddress($db);
							$smarty->assign("order", $order);
							$smarty->assign("shipping_is_free", $order->shippingIsFree);
							$quotes_result = $smarty->fetch("one-page-checkout/form-shipping-method.html");
							$objResponse->addScript("shipping_methods_array[0]=0;");
							$objResponse->addAssign("divSelectShippingMethod", "innerHTML", $quotes_result);
							$objResponse->addScript("order_properties['taxAmount']=".$order->taxAmount);
							
						}
						else{
							$order->getTaxRates($db);
							$order->openShipping($db);
							$order->checkShippingDigital($db);
							$order->checkFreeProducts($db);
							$order->recalcOrderData($db, $user->level);
							$order->getShippingAddress($db);
							$order->getHandlingAmount($db);
							$smarty->assign("order", $order);
						
							$r = getShippingQuotes($smarty, $db, $user, $order);
							$shipping_methods = $r["shipping_methods"];
							$shipping_methods_count = $r["shipping_methods_count"];
							$shipping_price_at_product_level = $r["shipping_price_at_product_level"];
							$shipping_tax_rate = $order->shippingTaxRate;
							$handling_tax_rate = $order->handlingTaxRate;
							$product_level_method = $r["product_level_method"];
							
							$smarty->assign("shipping_is_free", $order->shippingIsFree);
							$quotes_result = $smarty->fetch("one-page-checkout/form-shipping-method.html");
						
							if($r["international_error"] || $r["shipping_error"] || 
								(
									empty($r["shipping_methods"]) && 
									empty($r["product_level_method"]) && 
									$settings["ShippingWithoutMethod"] != "YES" &&
									$order->shippingIsFree == false
								)
							){
								$make_forms_textual = false;
								$objResponse->addAssign("div_form_bottom", "style.display", "none");
								$shipping_error_text = $smarty->fetch("one-page-checkout/form-shipping-error.html");
								$objResponse->addAssign("div_shipping_error", "innerHTML", $shipping_error_text);
								$objResponse->addAssign("div_shipping_error", "style.display", "block");
							}
							else{
								$objResponse->addAssign("div_form_bottom", "style.display", "block");
							}
							$objResponse->addScript("shipping_methods_array[0]=0;");
							$objResponse->addAssign("divSelectShippingMethod", "innerHTML", $quotes_result);
							$objResponse->addScript("order_properties['taxAmount']=".$order->taxAmount);
							
							if($product_level_method){
								$objResponse->addScript("shipping_methods_array[".$product_level_method["ssid"]."]=".$product_level_method["shipping_price"].";");
							}
							if(is_array($shipping_methods)){
								foreach($shipping_methods as $i=>$sm){
									$objResponse->addScript("shipping_methods_array[".$sm["ssid"]."]=".$sm["shipping_price"].";");
								}
							}
							
							//$objResponse->addScript("alert(shipping_methods_array)");
							
							$objResponse->addScript("shipping_price_at_product_level=".$shipping_price_at_product_level.";");
							$objResponse->addScript("shipping_methods_count=".$shipping_methods_count.";");
							$objResponse->addScript("shipping_tax_rate=".$shipping_tax_rate.";");
							$objResponse->addScript("handling_tax_rate=".$handling_tax_rate.";");
							$objResponse->addScript("sorder_properties['handlingTaxable']='".$order->handlingTaxable."';");
							$objResponse->addScript("order_properties['taxAmount']='".$order->taxAmount."';");
							$objResponse->addScript("opcSetShippingAndPayment()");
							if($r["international_error"] || $r["shipping_error"]){
								$objResponse->addScript("shipping_passed = 0;");
								$objResponse->addAssign("div_form_bottom_inside", "style.display", "none");
								$objResponse->addScript("opcSetProcessPaymentButtonStatus(0)");
							}
							else{
								if(($order->shippingIsFree || $shipping_methods_count > 0 || $product_level_method || $settings["ShippingWithoutMethod"] == "YES")){
									$objResponse->addScript("shipping_passed = 1;");
									$objResponse->addAssign("div_form_bottom_inside", "style.display", "block");
									$objResponse->addAssign("div_form_bottom", "style.display", "block");
									$objResponse->addScript("opcSetProcessPaymentButtonStatus(1)");
								}
								else{
									$objResponse->addScript("shipping_passed = 0;");
									$objResponse->addAssign("div_form_bottom_inside", "style.display", "none");
									$objResponse->addScript("opcSetProcessPaymentButtonStatus(0)");
								}
							}
						}
						$objResponse->addScript("opcSetShippingAndPayment(0)");
					}
					else{
						$objResponse->addScript("opcSetShippingAndPayment(0)");
						$objResponse->addScript("opcSetProcessPaymentButtonStatus(1)"); // commented after 3.5.3 R.687
					}

					if($action == "opc_set_addresses"){
						$objResponse->addScript("opcSubmitPaymentForm()");
					}
					
					if($action == "opc_continue_with_order" && $param2 == "ipn"){
						$objResponse->addScript("opcSetPaymentMethod()");
						$objResponse->addAssign("div_continue_with_order", "style.display", "none");
					}
					
					if($make_forms_textual){
						if($param1["paypal_ec_used"] == "0"){
							$cf_billing = $custom_fields->GetCustomFieldsValues("billing", $user->id, 0, 0);
							if($cf_billing){
								$smarty->assign("cf_billing", $cf_billing);
							}
							$smarty->assign("billing_address", $billing_address_data);
							$billing_address_view = $smarty->fetch("one-page-checkout/form-billing-address.html");
							$objResponse->addAssign("div_billing_address", "innerHTML", $billing_address_view);
							$objResponse->addAssign("div_edit_addresses_link", "style.display", "block");
						}
						
						if(!$order->shippingDigital){
							$shipping_address_data = $order->getShippingAddress($db);
							$smarty->assign("shipping_address", $shipping_address_data);
							$cf_shipping = $custom_fields->GetCustomFieldsValues("shipping", $user->id, $order->oid, 0);
							if($cf_shipping){
								$smarty->assign("cf_shipping", $cf_shipping);
							}
							$shipping_address_view = $smarty->fetch("one-page-checkout/form-shipping-address.html");
							$objResponse->addAssign("div_shipping_address", "innerHTML", $shipping_address_view);
						}
						
						$cf_invoice = $custom_fields->GetCustomFieldsValues("invoice", $user->id, $order->oid, 0);
						if($cf_invoice){
							$smarty->assign("cf_invoice", $cf_invoice);
							$cf_invoice_view = $smarty->fetch("one-page-checkout/form-invoice-cf.html");
							$objResponse->addAssign("div_invoice_cf", "innerHTML", $cf_invoice_view);
						}
						
						if($settings["GiftCardActive"] == "YES"){
							$gift_message_view = $smarty->fetch("one-page-checkout/form-gift-message.html");
							$objResponse->addAssign("div_gift_message", "innerHTML", $gift_message_view);
						}
						else{
							$objResponse->addAssign("div_gift_message", "innerHTML", "None");
						}
					}
					$smarty->assign("order_items", $order->getOrderItems($db));
					$order_content = $smarty->fetch("one-page-checkout/form-order-content.html");
					$objResponse->addAssign("div_order_content", "innerHTML", $order_content);
					
					$objResponse->addAssign("div_progress", "style.display", "none");
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
				}
				break;
			}
			
			case "opc_set_additional_info_and_shipping_method" :
			case "opc_set_additional_info" : {
				if($user->auth_ok){
					//check custom fields
					$custom_field = isset($param1["custom_field"])?$param1["custom_field"]:array();
					$custom_field = is_array($custom_field)?$custom_field:array();
					$custom_fields->StoreCustomFields("invoice", $custom_field, $user->id, $order->oid, 0);
					if($settings["GiftCardActive"] == "YES" && isset($param1["add_gift"]) && $param1["gift_message"] != ""){
						$order->storeGiftMessage($db, $param1["gift_message"]);
					}
					$objResponse->addAssign("div_progress", "style.display", "none");
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
					break;
				}
				if($action == "opc_set_additional_info"){
					$objResponse->addScript("opcSubmitPaymentForm();");
					break;
				}
			}
			
			case "opc_set_shipping_method" : {
				if($user->auth_ok){
					$shipping_method = $action == "opc_set_shipping_method" ? $param1 : $param2;
					$result = $order->updateShippingMethod($db, $shipping_method);
					if($shipping_method > 0){
						$order->getShippingAmount($db, $error_message);
					}
					$order->closeShipping($db);
					$order->checkFreeProducts($db);
					$order->recalcOrderData($db, $user->level);
				
					$todo = $shipping_method = $action == "opc_set_shipping_method" ? $param2 : $param3;
					
					if($todo == "refreshPaymentMethod"){
						$objResponse->addScript("opcSetPaymentMethod();");
					}
					
					if($todo == "submitPaymentForm"){
						$objResponse->addScript("opcSubmitPaymentForm();");
					}
					$objResponse->addScript("opcSetProcessPaymentButtonStatus(1)");
					$objResponse->addAssign("div_progress", "style.display", "none");
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
				}
				break;
			}
			
			case "opc_set_payment_method" : {
				if($user->auth_ok){
					$smarty->assign("auth_express", $user->express?"yes":"no");
					
					$payment_method_id = $param1;
			
					$order->updatePaymentMethod($db, $payment_method_id);
					
					$_SESSION["pc_method_id"] = $order->paymentMethodId;
					$order->setOrderNum($db);
					$order->setAbandonStatus($db);
					
					$order->getOrderData($db);
					
					$smarty->assign("order_num", $order->order_num);
					$smarty->assign("order", $order);
					
					if(!isset($payment)){
						$payment = new PAYMENT($db);
					}
					
					$payment_url = $url_https."p=one_page_checkout";
					
					if($payment->isMethod($order->paymentMethodId) || $order->paymentMethodId == 0){
						//free payment
						if($order->paymentMethodId == 0){
							$payment_method = new PAYMENT_METHOD(
								0, // pid
								"http", // proto
								"custom", // type
								"", // url to gateway
								"Free", // name
								$msg["billing"]["order_is_free_title"], // form title
								$msg["billing"]["order_is_free_text"], // message payment
								"", // message thak you
								"free", // id
								""
							);
						}
						//custom / realtime gateway
						else{
							$payment_method = $payment->methods[$order->paymentMethodId];
						}
						
						//check if here HTTPS
						$smarty->assign("payment_url", $payment_method->protocol == "https" ? $url_https : $url_dinamic);
						$smarty->assign("payment_method", $payment_method);
						$smarty->assign("validator_code", "");
						
						if($order->paymentIsRealtime == "Yes"){
							
							$order->getShippingAddress($db);

							@require_once("content/engine/payment/payment_".($payment_method->id).".php");
							eval("\$payment_gateway = new ".$payment_processor_class."();");
							$payment_gateway->payment_page = "one_page_checkout";
							$payment_gateway->protocol = $payment_method->protocol;
							$payment_gateway->db_id = $order->paymentMethodId;
							$payment_gateway->getSettingsData($db);
							$payment_gateway->assignUser($user);
							$payment_gateway->assignOrder($order);
							$order_items = $order->getOrderItems($db);
							$payment_gateway->assignOrderItems($order_items);
							$payment_gateway->getCommonData($user, $order);
							$payment_test_mode = $payment_gateway->isTestMode();
							$smarty->assign("payment_test_mode", $payment_test_mode?"yes":"no");
							
							$payment_url = $payment_gateway->getPostUrl();
							if(trim($payment_url)!=""){
								$smarty->assign("payment_url", $payment_url);
							}
							else{
								if($payment_method->protocol == "https"){
									$payment_url = $url_https."p=one_page_checkout";
								}
								else{
									$payment_url = $url_https."p=one_page_checkout";
								}
							}
							
							$smarty->assign("payment_url", $payment_url);
							$smarty->assign("payment_form", $payment_gateway->getPaymentForm($db));
							$smarty->assign("validator_code", $payment_gateway->getValidatorJS());
							$smarty->assign("show_cvv2_info", $payment_gateway->show_cvv2);
							$smarty->assign("is_payment_error", $payment->is_error?"yes":"no");
							$smarty->assign("payment_error_message", $payment->error_message);
							$smarty->assign("payment_gateway_id", $payment_gateway->id);
							$set_session_order_vars = true;
						}
						else{
							$smarty->assign("payment_realtime", "no");
							$set_session_order_vars = true;
						}
					}
					
					if($order->paymentMethodId != 0){
						$payment_form = $smarty->fetch("one-page-checkout/form-payment-method.html");
						$objResponse->addAssign("divPaymentForm", "innerHTML", $payment_form);
					}
					
					$objResponse->addAssign("frmPayment", "action", $payment_url);
					$objResponse->addScript("opcSetProcessPaymentButtonStatus(1)");
					$objResponse->addAssign("div_progress", "style.display", "none");
					
										//gift cerificate
					if($order->gift_cert_amount > 0 && $order->totalAmount > $order->gift_cert_amount){
					//GC fix Dont call this on each page load becuase it was casuing issue on OPC
						//$objResponse->addAssign("gift_cert_error", "style.display", "none");
						//$objResponse->addAssign("gift_cert_alt_payment", "style.display", "block");
						//$objResponse->addScript("altPaymentGiftCert('$order->totalAmount', '$order->gift_cert_amount')");
					}
					
					$_SESSION["pc_order_id"] = $order->oid;
					$_SESSION["pc_order_amount"] = $order->totalAmount - $order->shippingAmount - $order->taxAmount - ($order->handlingSeparated ? $order->handlingAmount : 0.00);
					$_SESSION["pc_method_id"] = $order->paymentMethodId;
					$_SESSION["pc_order_quantity"] = $order->itemsCount;
					$_SESSION["pc_order_num"] = $order->order_num;
					
				}
				else{
					$objResponse->addScript("document.location='index.php?p=auth_error';");
				}

				break;
			}	

			case "setup_google_checkout" : {
				$address =array();
				$address["name"] = "";
                $address["company"] = "";
                $address["address1"] = "";
				$address["address2"] = "";
				$address["city"] = "";
				$address["state"] = "";
				$address["province"] ="";
				$address["country"] = 1; 
				$address["country_code"] = "US";
				
				//For UK postal codes
				if(eregi('^(([A-Z]{1,2}[0-9][0-9A-Z]{0,1})\ ([0-9][A-Z]{2}))|(GIR\ 0AA)$', $param1)){
    				$db->query("SELECT coid,iso_a2 FROM ".DB_PREFIX."countries WHERE iso_a2='GB'");
					$address["country"] = $db->movenext() ? $db->col["coid"] : 0;
					$address["country_code"] = $db->col["iso_a2"];
				}
				else{
				//For USA postal codes
   					$db->query("SELECT coid,iso_a2 FROM ".DB_PREFIX."countries WHERE iso_a2='US'");
					$address["country"] = $db->movenext() ? $db->col["coid"] : 1;
					$address["country_code"] = $db->col["iso_a2"];
					$state = validstatezip($param1);
					$state_id = getStateId($db,$state);
					$address["state"] = $state_id;
				}
				$address["zip"] = $param1;
				
				$order->updateShippingAddress($db, $address);
				$order->getShippingAmount($db, $error_message);
				
				$r = getShippingQuotes($smarty, $db, $user, $order);
				$shipping_methods_list = $r["shipping_methods"];
				
				@require_once("content/engine/payment/payment_googlecheckout.php");
				$payment_gateway = new PAYMENT_GOOGLECHECKOUT();
				$payment_form= $payment_gateway->getPaymentForm($db,$shipping_methods_list,$address);
				
				$objResponse->addAssign('signature', 'value', $payment_form[0]);
				$objResponse->addAssign('cart', 'value', $payment_form[1]);
				$db->reset();
				$db->assign_str("custom1", "Google Checkout order");
				$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
				//$order->newCart($db, $user->id);
				$objResponse->addScript('document.forms["frmGoogle"].submit();');				
				break;
			}
		}

		return $objResponse->getXML();
	}
?>
